local dir = "sys/lua/RP_Aaa789/saves/"
PLAYERS = {}

function addmoney(id, amount)
     if PLAYERS[id].money + amount >= 0 then
          parse(string.format("setmoney %i 0", id))
          PLAYERS[id].money = PLAYERS[id].money + amount
          parse(string.format("hudtxt2 %i 49 \"c255100100Money : %i\" 0 100", id, PLAYERS[id].money))
          return true
     end
     return false
end

function getmoney(id)
     return PLAYERS[id].money
end

addhook("join", "RPjoin")
function RPjoin(id)
     local playerfile = io.open(dir..player(id,"usgn")..".txt","r")
     if playerfile then
          PLAYERS[id] = {}
          for v in playerfile:lines() do
               local find = v:find"="
               key = v:sub(1,find-1)
               key = tonumber(key) or key
               val = v:sub(find+1)
               val = tonumber(val) or val
               PLAYERS[id][key] = val
          end
          playerfile:close()
     else
          PLAYERS[id] = {
               money = 0,
          }
     end
end

addhook("second", "RPsecond")
function RPsecond()
     for _, id in ipairs(player(0, "table")) do
          parse(string.format("setmoney %i 0", id))
          if PLAYERS[id] then
               parse(string.format("hudtxt2 %i 49 \"Money : %i\" 0 0", id, PLAYERS[id].money))
          end
     end
end

addhook("leave", "RPleave")
function RPleave(id)
     if PLAYERS[id] and player(id,"usgn") ~= 0 then
          local playerfile = io.open(dir .. player(id,"usgn") .. ".txt","w+") or io.tmpfile()
          local text = ""
          for i, v in pairs(PLAYERS[id]) do
               text = text .. i .. "=" .. tostring(v) .. "\n"
          end
          text = text:sub(1,-2)
          playerfile:write(text)
          playerfile:close()
     end
     PLAYERS[id] = nil
end

addhook("collect", "RPcollect")
function RPcollect(id,iid,type,ain,a,mode)
     if type == 66 then
          addmoney(id, 100)
     elseif type == 67 then
          addmoney(id, 1000)
     elseif type == 68 then
          addmoney(id, 10000)
     end
end

addhook("menu", "RPmenu")
function RPmenu(id, title, button)
     if title == "Drop Money" then
          if button == 0 then
               return
          end
          menu(id, "Drop Money,100,500,1000,5000,10000,50000,100000")
          if button == 1 then
               if addmoney(id, -100) then
                    parse(string.format("spawnitem 66 %i %i", player(id, "tilex"), player(id, "tiley")))
               end
          elseif button == 2 then
               if addmoney(id, -500) then
                    local spawn = string.format("spawnitem 66 %i %i", player(id, "tilex"), player(id, "tiley"))
                    for i = 1, 5 do
                         parse(spawn)
                    end
               end
          elseif button == 3 then
               if addmoney(id, -1000) then
                    parse(string.format("spawnitem 67 %i %i", player(id, "tilex"), player(id, "tiley")))
               end
          elseif button == 4 then
               if addmoney(id, -5000) then
                    local spawn = string.format("spawnitem 67 %i %i", player(id, "tilex"), player(id, "tiley"))
                    for i = 1, 5 do
                         parse(spawn)
                    end
               end
          elseif button == 5 then
               if addmoney(id, -10000) then
                    parse(string.format("spawnitem 68 %i %i", player(id, "tilex"), player(id, "tiley")))
               end
          elseif button == 6 then
               if addmoney(id, -50000) then
                    local spawn = string.format("spawnitem 68 %i %i", player(id, "tilex"), player(id, "tiley"))
                    for i = 1, 5 do
                         parse(spawn)
                    end
               end
          elseif button == 7 then
               if addmoney(id, -100000) then
                    local spawn = string.format("spawnitem 68 %i %i", player(id, "tilex"), player(id, "tiley"))
                    for i = 1, 10 do
                         parse(spawn)
                    end
               end
          end
     end
end

addhook("serveraction", "RPserveraction")
function RPserveraction(id,action)
     if action == 2 then
          menu(id, "Drop Money,100,500,1000,5000,10000,50000,100000")
     end
end

addhook("movetile", "RPmovetile")
function RPmovetile(id,x,y)
     if PLAYERS[id].x and PLAYERS[id].y and entity(x, y, "typename") ~= "Info_T" and entity(x, y, "typename") ~= "Info_CT" then
          PLAYERS[id].x, PLAYERS[id].y = x, y
     end
end

addhook("spawn", "RPspawn")
function RPspawn(id)
     if PLAYERS[id].x and PLAYERS[id].y then
          parse(string.format("setpos %i %i %i", id, PLAYERS[id].x*32+16, PLAYERS[id].y*32+16))
     end
     return ""
end

addhook("die", "RPdie")
function RPdie(victim,killer,weapon,x,y)
     PLAYERS[victim].x, PLAYERS[victim].y = nil, nil
end

addhook("minute","min")
function RPminute()
     for _, id in ipairs(player(0, 'table') do
          if not player(id, 'idle') then
               addmoney(id, 1000)
          end
     end
     --msg('Toady is Payday! Everyone gets $1000')
end